// TestTemplateSet.h : interface of the CTestTemplateSet class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTTEMPLATESET_H__597E64CF_7C6E_11D5_B617_B1705EF8615B__INCLUDED_)
#define AFX_TESTTEMPLATESET_H__597E64CF_7C6E_11D5_B617_B1705EF8615B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCategories
{
public:
	CCategories()
	{
		memset( (void*)this, 0, sizeof(*this) );
	};

	int m_CategoryID;
	char m_CategoryName[16];
	char m_Description[1025];	//TODO: Change this large string to an ISequentialStream if your provider supports it.
	ISequentialStream* m_Picture;


BEGIN_COLUMN_MAP(CCategories)
		COLUMN_ENTRY_TYPE(1, DBTYPE_I4, m_CategoryID)
		COLUMN_ENTRY_TYPE(2, DBTYPE_STR, m_CategoryName)
		COLUMN_ENTRY_TYPE(3, DBTYPE_STR, m_Description)
		BLOB_ENTRY(4, IID_ISequentialStream, STGM_READ, m_Picture)
END_COLUMN_MAP()

};

class CTestTemplateSet : public CCommand<CAccessor<CCategories> >
{
public:

	HRESULT Open()
	{
		CDataSource db;
		CSession	session;
		HRESULT		hr;

		CDBPropSet	dbinit(DBPROPSET_DBINIT);
		dbinit.AddProperty(DBPROP_AUTH_CACHE_AUTHINFO, true);
		dbinit.AddProperty(DBPROP_AUTH_ENCRYPT_PASSWORD, false);
		dbinit.AddProperty(DBPROP_AUTH_MASK_PASSWORD, false);
		dbinit.AddProperty(DBPROP_AUTH_PASSWORD, "");
		dbinit.AddProperty(DBPROP_AUTH_PERSIST_ENCRYPTED, false);
		dbinit.AddProperty(DBPROP_AUTH_PERSIST_SENSITIVE_AUTHINFO, false);
		dbinit.AddProperty(DBPROP_AUTH_USERID, "Admin");
		dbinit.AddProperty(DBPROP_INIT_DATASOURCE, "C:\\MSDASDK\\bin\\oledb\\Nwind.mdb");
		dbinit.AddProperty(DBPROP_INIT_MODE, (long)16);
		dbinit.AddProperty(DBPROP_INIT_PROMPT, (short)4);
		dbinit.AddProperty(DBPROP_INIT_PROVIDERSTRING, ";COUNTRY=0;CP=1252;LANGID=0x0409");
		dbinit.AddProperty(DBPROP_INIT_LCID, (long)1033);

		hr = db.OpenWithServiceComponents("Microsoft.Jet.OLEDB.3.51", &dbinit);
		if (FAILED(hr))
			return hr;

		hr = session.Open(db);
		if (FAILED(hr))
			return hr;

		CDBPropSet	propset(DBPROPSET_ROWSET);
		propset.AddProperty(DBPROP_CANFETCHBACKWARDS, true);
		propset.AddProperty(DBPROP_IRowsetScroll, true);
		propset.AddProperty(DBPROP_IRowsetChange, true);
		propset.AddProperty(DBPROP_UPDATABILITY, DBPROPVAL_UP_CHANGE | DBPROPVAL_UP_INSERT | DBPROPVAL_UP_DELETE );

		hr = CCommand<CAccessor<CCategories> >::Open(session, "SELECT * FROM Categories", &propset);
		if (FAILED(hr))
			return hr;

		return MoveNext();
	}

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTTEMPLATESET_H__597E64CF_7C6E_11D5_B617_B1705EF8615B__INCLUDED_)

